//1050,"propvat.sc","Proporcja VAT",1.33,SYSTEM
//Copyright (c) Sage sp. z o.o.. Wszelkie prawa zastrzeone.

// wzr dla proporcji VAT
#define PROPWZOR "P(%) = O(p)-O(t)-O(tf) / O(p)+O(n)+S-O(t)-O(tf) x 100"

#include "hfall.sci"
#include "defdok.sci"
#include "form.sci"
#include "grid.sci"
#include "limits.sci"

typwydruku = TYPWYDRUKU_GRAPH
setStrona( 1900, 0, 0 )
strona 50, 200, 50, 200

int sLT = Styl( "tekst", GRID_COLALIGN_LEFT )
int sCT = Styl( "tekst", GRID_COLALIGN_CENTER )
int sRK = Styl( "kwota", GRID_COLALIGN_RIGHT )
int sLTB = Styl( CopyFont("tekst", 1), GRID_COLALIGN_LEFT )
int sCTB = Styl( CopyFont("tekst", 1), GRID_COLALIGN_CENTER )
int sRKB = Styl( CopyFont("kwota", 1), GRID_COLALIGN_RIGHT )

int tblNglParam = tabela 1, 10, 150, sCTB, 150, sCTB, str.szer-500, sCTB, 200, sCTB
int tblParam =    tabela 1, 10, 150, sCTB, 150, sCTB, str.szer-500, sLTB, 200, sRKB

int tblNglVAT = tabela 1, 10, 150, sCTB, 150, sCTB, str.szer-1050, sCTB, 200, sCTB, 200, sCTB, 200, sCTB
int tblVAT =    tabela 1, 10, 150, sCT, 150, sLT, str.szer-1050, sLT, 200, sCT, 200, sRK, 200, sRK

int iOstatniRok, bufor, daneVAT, idxParam, i, err
long idxRej, indx
string key, okresOd, okresDo, lstLata(1)

string lstMies( 12 )
i = 1
while i <= 12
	lstMies(i) = rzymskie(i)
	i += 1
wend
i = 0

BASEHANDLE bVatTab( 2 ), bDef = dbOpen( "defRej", true )
bVatTab( 1 ) = dbOpenVatBase( ZRODLO_KSIEGI, true )
bVatTab( 2 ) = dbOpenVatBase( ZRODLO_BUFOR, true )

nazwaRaportu = getReportName()

mapValue mapZnacznik : mapZnacznik.Type(string)
string sZnacznik
string tabZnacznik(1)

#define TYPE__COUNT 5
#define TYPE_OP 1
#define TYPE_ON 2
#define TYPE_S 3
#define TYPE_OST 4
#define TYPE_OTF 5

mapValue lstMapParam( TYPE__COUNT )
i = 1
while i <= TYPE__COUNT
	lstMapParam( i ).Type( long )
	i += 1
wend
i = 0

string nameParam( TYPE__COUNT ), skrotParam( TYPE__COUNT )

nameParam( TYPE_OP ) = "Obrt z tytuu czynnoci, w zwizku z ktrymi przysuguje prawo do odliczenia"
skrotParam( TYPE_OP ) = "O(p)"

nameParam( TYPE_ON ) = "Obrt z tytuu czynnoci, w zwizku z ktrymi nie przysuguje prawo do odliczenia"
skrotParam( TYPE_ON ) = "O(n)"

nameParam( TYPE_S ) = "Dotacje i subwencje inne ni wczone do podstawy opodatkowania"
skrotParam( TYPE_S ) = "S"

nameParam( TYPE_OST ) = "Obrt z tytuu sprzeday rodkw trwaych"
skrotParam( TYPE_OST ) = "O(t)"

nameParam( TYPE_OTF ) = "Obrt z tytuu transakcji dotyczcych nieruch. oraz usug finansowych, wykonywanych sporadycznie"
skrotParam( TYPE_OTF ) = "O(tf)"

string strProp, znacznikParam( TYPE__COUNT )
float licznik, mianownik, proporcja, sumParam( TYPE__COUNT )

record recREJESTR
	string okr[8]
	string nrew[1+NREW_MAXLEN]
	string nrwl[1+DOK_NAZWA_MAXLEN]
	float netto, brutto, vat, stawka 	
endrec	
recREJESTR lstRej(1)

int sub Opis(int pierwszy)
endsub

int sub Legenda()
	SetFont("tekst")
	DataSystemowa.TodayTime()
	print using "Wykonano dnia: %s.\n", Mid(DataSystemowa.DateToStr(), 1, 10)
	print using "Okres: od %s do %s.\n", okresOd, okresDo
	if bufor == 2 then print "Uwzgldniono dokumenty z bufora.\n"
endsub

int sub Podsumowanie(int ostatni)
endsub

int sub FillTabZnaczniki()
	BASEHANDLE bXT = dbOpen( "amxtfk", true )
	int errXT, idx
	setKey( bXT, "super" )
	setKeySeg( bXT, "super", ZT_REJESTR )
	errXT = GetRec(bXT, GE)
	while !errXT && GetField(bXT, "super") == ZT_REJESTR
		if GetField(bXT, "subtyp") then
			mapZnacznik.Get((using "%c", Val(GetField(bXT, "subtyp"))), GetField(bXT, "kod"))
		endif
		errXT = GetRec(bXT, NX)
	wend	
	mapZnacznik.Sort()
	for idx = 1 to idx > mapZnacznik.Size()
		if tabZnacznik(1) != "" then grow tabZnacznik, 1
		tabZnacznik(Size(tabZnacznik)) = using "%s - %s", mapZnacznik.GetKey(idx), mapZnacznik.Get(idx)
	next idx
	dbClose( bXT )
endsub

int sub GetOstatniRokId()
	string rokOd_, rokDo_
	BASEHANDLE bFrok
	int errFrok
	bFrok = dbOpen( "frok", true )
	setKey(bFrok, "rok")
	setKeySeg(bFrok, "rokId", IndeksRoku())
	errFrok = GetRec(bFrok, EQ)
	if !errFrok then
		rokOd_ = Mid(GetField(bFrok, "poczatek"), 1, 4)
		rokDo_ = Mid(GetField(bFrok, "koniec"), 1, 4)
		lstLata(1) = rokOd_
		if rokOd_ != rokDo_ then
			grow lstLata, 1
			lstLata(2) = rokDo_
		endif
	endif
	errFrok = GetRec(bFrok, LS)
	if !errFrok then GetOstatniRokId = GetField(bFrok, "rokId")
	dbClose( bFrok )
endsub

string rokOd, rokDo, miesOd, miesDo
int iRokOd, iMiesOd, iRokDo, iMiesDo, iDaysDo
int cbRokDo, cbMiesDo
int cb

int sub GetMonthsInfo()
	for iMiesOd = 1 to iMiesOd > 12
		if rzymskie( iMiesOd ) == miesOd then goto labelDo
	next iMiesOd
labelDo:
	for iMiesDo = 1 to iMiesDo > 12
		if rzymskie( iMiesDo ) == miesDo then goto labelDay
	next iMiesDo
labelDay:
	iRokOd = Val( rokOd )
	iRokDo = Val( rokDo )
	if iRokOd < iRokDo then
		GetMonthsInfo = 1
	else 
		if iRokOd == iRokDo then
			GetMonthsInfo = ( iMiesOd <= iMiesDo )
			cb = cbMiesDo
		else
			GetMonthsInfo = 0
			cb = cbRokDo
		endif
	endif
	iDaysDo = dateutilOstatniDzien( iRokDo, iMiesDo )
endsub

int sub onOK()
	Save
	if GetMonthsInfo() then
		onOK = FORMRETVAL_IDOK
	else
		Message "Nieprawidowy okres kalendarzowy. ico:!"
		SetActive( cb )
		onOK = 1
	endif
endsub

#define INISEC "ProporcjaVAT"
#define INIKEY_BUF "Bufor"
#define INIKEY_DVAT "DaneVAT"
#define INIKEY_ROKOD "RokOd"
#define INIKEY_MCOD "MiesOd"
#define INIKEY_ROKDO "RokDo"
#define INIKEY_MCDO "MiesDo"

string sub INIKEY_ZNPAR( int idx )
	INIKEY_ZNPAR = using "ZnacznikParam%d", idx
endsub

int sub Dialog()
	int idx
	string zn
	
	for idx = TYPE_ON to idx > TYPE__COUNT
		zn = GetIni(INISEC, INIKEY_ZNPAR(idx), PlikFK())	
		if zn && mapZnacznik.Index(zn) then znacznikParam(idx) = using "%s - %s", zn, mapZnacznik.Get(zn)
	next idx
	bufor = Val(GetIni(INISEC, INIKEY_BUF, PlikFK()))
	daneVAT = val(GetIni(INISEC, INIKEY_DVAT, PlikFK()))
	rokOd = GetIni(INISEC, INIKEY_ROKOD, PlikFK())
	miesOd = GetIni(INISEC, INIKEY_MCOD, PlikFK())
	rokDo = GetIni(INISEC, INIKEY_ROKDO, PlikFK())
	miesDo = GetIni(INISEC, INIKEY_MCDO, PlikFK())
	
	form "Obliczanie proporcji VAT", 560, 400
		Text ( using "Wzr: %s, obliczany dla okresu kalendarzowego", PROPWZOR ), 20, 10, 480, 20
		Text "od:", 20, 30, 20, 20
		CmbBox "", lstLata, rokOd, 40, 30, 55, 100
		CmbBox "", lstMies, miesOd, 95, 30, 40, 200
		Text "do:", 155, 30, 20, 20
		cbRokDo = CmbBox "", lstLata, rokDo, 175, 30, 55, 100
		cbMiesDo = CmbBox "", lstMies, miesDo, 230, 30, 40, 200
		
		Text "[Wyliczany automatycznie]", 20, 80, 240, 20
		Group skrotParam( TYPE_OP ), 10, 60, 260, 80
		Text nameParam( TYPE_OP ), 20, 105, 240, 50
		
		Group skrotParam( TYPE_ON ), 280, 60, 260, 80
		CmbBox "", tabZnacznik, znacznikParam( TYPE_ON ), 290, 80, 240, 90
		Text nameParam( TYPE_ON ), 290, 105, 240, 50
	
		Group skrotParam( TYPE_S ), 10, 150, 260, 80
		CmbBox "", tabZnacznik, znacznikParam( TYPE_S ), 20, 170, 240, 90
		Text nameParam( TYPE_S ), 20, 195, 240, 50
		
		Group skrotParam( TYPE_OST ), 280, 150, 260, 80
		CmbBox "", tabZnacznik, znacznikParam( TYPE_OST ), 290, 170, 240, 90
		Text nameParam( TYPE_OST ), 290, 195, 240, 50
		
		Group skrotParam( TYPE_OTF ), 10, 240, 260, 80
		CmbBox "", tabZnacznik, znacznikParam( TYPE_OTF ), 20, 260, 240, 90
		Text nameParam( TYPE_OTF ), 20, 285, 240, 50
		
		ChkBox "Uwzgldnij dane z bufora", bufor, 280, 250, 160, 24
		ChkBox "Dane szczegowe rejestrw VAT", daneVAT, 280, 280, 180, 24
	
		Button FORMTEXT_IDOK, 95, 340, 96, 24, onOK()
		Button FORMTEXT_IDCANCEL, 370, 340, 96, 24, FORMRETVAL_IDCANCEL
	if ExecForm != FORMRETVAL_IDOK then error ""
	
	for idx = TYPE_ON to idx > TYPE__COUNT 
		PutIni(INISEC, INIKEY_ZNPAR(idx), Mid(znacznikParam(idx), 1, 1), PlikFK())
	next idx
	PutIni(INISEC, INIKEY_BUF, (using "%d", bufor), PlikFK())
	PutIni(INISEC, INIKEY_DVAT, (using "%d", daneVAT), PlikFK())
	PutIni(INISEC, INIKEY_ROKOD, rokOd, PlikFK())
	PutIni(INISEC, INIKEY_MCOD, miesOd, PlikFK())
	PutIni(INISEC, INIKEY_ROKDO, rokDo, PlikFK())
	PutIni(INISEC, INIKEY_MCDO, miesDo, PlikFK())
	
	okresOd = using "%04d-%02d-01", iRokOd, iMiesOd
	okresDo = using "%04d-%02d-%02d", iRokDo, iMiesDo, iDaysDo
	bufor += 1

	hfallNaDzien = okresDo
endsub

//Zgodnie z opisem w #21921:
//"wyliczenie O(p) jest bdny. Do zmiennej O(p) powinny by te dodawane kwoty ze znacznikiem  O(t) i O(tf) i dopiero wtedy powinno si zastosowa wzr jak w programie, czyli O(p)-O(t)-O(tf) / O(p)+O(n)-O(t)-O(tf) x 100."
//#28990:
//na licie O (p) powinny by te wykazane dokumenty z O (t) i O (tf)

void sub ustawIdxParam( int srTrwale, string znacznik, int stawka )
	idxParam = 0
	select case znacznik
	case Mid(znacznikParam( TYPE_ON ), 1, 1)
		idxParam = TYPE_ON
	case Mid(znacznikParam( TYPE_S ), 1, 1)
		idxParam = TYPE_S
	case Mid(znacznikParam( TYPE_OST ), 1, 1)
		idxParam = TYPE_OST
	case Mid(znacznikParam( TYPE_OTF ), 1, 1)
		idxParam = TYPE_OTF
	case else
		if FKUTIL_PODTYPREJ_NPO != srTrwale && STAWKA_ZWOL != stawka then
			idxParam = TYPE_OP
		endif
	endselect				
endsub

// Format dla nrEwSortKey
string nrEwSortKeyFmt = using "%%-%d.%ds%%%dd%%%dl", DOK_SKROT_MAXLEN, DOK_SKROT_MAXLEN, len( using "%d", INT_MAX ), len( using "%d", LONG_MAX )

// Klucz na podstawie numeru ewidencyjnego, nadajcy si do sortowania alfanumerycznego.
// Przekazywa skrot, okres i numer z dokumentu.
string sub nrEwSortKey( string skr, int okr, long num )
	nrEwSortKey = using nrEwSortKeyFmt, skr, okr, num
endsub

#ifdef FORTE

Dispatch conn, rs
conn = GetAdoConnection()
rs = "ADODB.Recordset"

int sub AddRejToType()
	if lstRej(1).nrew then grow lstRej, 1
	idxRej = Size(lstRej)
//
	lstRej(idxRej).okr = Mid(AdoStr(rs, "okres"), 1, 7)
	lstRej(idxRej).nrew = rsNrEwToStr( rs )
	lstRej(idxRej).nrwl = AdoStr(rs, "numerWl")
	lstRej(idxRej).netto = rs.Fields("netto").Value
	lstRej(idxRej).brutto = rs.Fields("brutto").Value
	lstRej(idxRej).vat = rs.Fields("vat").Value
	lstRej(idxRej).stawka = rs.Fields("stawka").Value

	string keyNrEw = nrEwSortKey( adoStr( rs, "skrot"), rs.fields( "okresDok" ).value, rs.fields( "numer" ).value )
	key = using "%s_%s_%l", lstRej(idxRej).okr, keyNrEw, rs.Fields("id").Value

	lstMapParam(idxParam).Get(key, idxRej)
	sumParam(idxParam) += rs.Fields("netto").Value
endsub

int sub Rejestr()
	string sSQL, nazwaRej
    long cnt = 0
	sSQL += "SELECT rv.*, d.skrot, d.okres as okresDok, d.numer, d.dataokr, d.zrodlo, dr.srTrwale FROM rejVat rv "
	sSQL += "JOIN defRej dr ON dr.id = rv.def "
	sSQL += "JOIN dokumenty d ON rv.rokDok = d.rokId AND rv.dId = d.id "
	sSQL += using "WHERE (dr.rZs = %d OR dr.rZs = %d) ", FKUTIL_TYPREJ_SPRZEDAZ, FKUTIL_TYPREJ_EKSPORT
	sSQL += using "AND rv.okres BETWEEN '%s' AND '%s' ", okresOd, okresDo
	//sSQL += using "AND dr.wykazuj = 1 AND dr.srTrwale <> %d ", FKUTIL_PODTYPREJ_DT // WI 110747
	//sSQL += using "AND d.wzorzec <> %d ", DW_FAKTURA_WNT // WI 110525
	sSQL += using "AND dr.wykazuj = 1 AND (d.wzorzec <> %d AND rv.ue = 0) ", DW_FAKTURA_WNT // WI 110525
	sSQL += "AND (CHARINDEX('FP', d.atrJpkV7) = 0) " // nie uwzgldniamy faktur do paragonw
	sSQL += using "AND d.zrodlo < %d ", bufor
	sSQL += "ORDER BY rv.def"

	rs.Open(sSQL, conn)
	
	while !rs.Eof()
		ustawIdxParam( rs.Fields("srTrwale").Value, (using "%c", Val(AdoStr(rs, "znacznik"))), rs.Fields("stawka").Value )
		if idxParam	then
			AddRejToType()
			if TYPE_OST == idxParam || TYPE_OTF == idxParam then
				idxParam = TYPE_OP
				AddRejToType()
			endif
			cnt = cnt + 1
			if cnt % 100 == 0 then Popup(3, cnt)
		endif
		rs.MoveNext()
	wend

	rs.Close()
endsub

#else

int iBas

int sub AddRejToType( int bVat )
	if lstRej(1).nrew then grow lstRej, 1
	idxRej = Size(lstRej)
	lstRej(idxRej).okr = Mid(GetField(bVat, "okres"), 1, 7)
	lstRej(idxRej).nrew = dbNrEwToStr_Vat( bVat )
	lstRej(idxRej).nrwl = GetField(bVat, "numerWl")
	lstRej(idxRej).netto = GetField(bVat, "netto")
	lstRej(idxRej).brutto = GetField(bVat, "brutto")
	lstRej(idxRej).vat = GetField(bVat, "vat")
	lstRej(idxRej).stawka = GetField(bVat, "stawka")

	ZRODLOTYPE zr
	if 1 == iBas then
		zr = ZRODLO_KSIEGI
	else
		zr = ZRODLO_BUFOR
	endif
	BASEHANDLE bDok = dbOpenDokBase( getField( bVat, "rokDok" ), zr, false )
	setKey( bDok, "id" )
	setKeySeg( bDok, "id", getField( bVat, "dId" ) )
	getRec( bDok, EQ )
	key = using "%s_%s_%l", lstRej(idxRej).okr, nrEwSortKey( getField( bVat, "dSkrot" ), getField( bDok, "okres" ), getField( bVat, "dNumer" ) ), GetField(bVat, "id")

	lstMapParam(idxParam).Get(key, idxRej)
	sumParam(idxParam) += GetField(bVat, "netto")
endsub 

int sub Rejestr( int def, int srTrwale )
	ddInfo ddi
	int iRok, errVat, bVat
	for iBas = 1 to iBas > bufor
		bVat = bVatTab(iBas)
		for iRok = 0 to iRok > iOstatniRok
			SetKey(bVat, "sort_sprz")
			SetKeySeg(bVat, "def", def)
			SetKeySeg(bVat, "rokDok", iRok)
			SetKeySeg(bVat, "okres", okresOd)
			errVat = GetRec(bVat, GE)
			while !errVat && GetField(bVat, "def") == def && GetField(bVat, "rokDok") == iRok && GetField(bVat, "okres") <= okresDo		
				if ! defdokGetInfo( iRok, GetField(bVat, "dSkrot"), ddi ) || DW_FAKTURA_WNT != ddi.d.wzor then // WNT wykluczamy na mocy WI 110525
					ustawIdxParam( srTrwale, (using "%c", Val(GetField(bVat, "znacznik"))), GetField(bVat, "stawka") )
					if idxParam	then	
						AddRejToType( bVat )
						if TYPE_OST == idxParam || TYPE_OTF == idxParam then
							idxParam = TYPE_OP
							AddRejToType( bVat )
						endif
					endif
				endif
				errVat = GetRec(bVat, NX)
			wend
		next iRok
	next iBas
endsub

#endif

if (Message "Poprawne wyznaczenie wspczynnika proporcji VAT uwarunkowane jest wczeniejszym nadaniem waciwych znacznikw rejestrom VAT z danego roku kalendarzowego. Czy znaczniki zostay ju nadane? DefBtn: &Tak = 10 Btn: &Nie = 1  Ico: !") != 10 then error ""

FillTabZnaczniki()
iOstatniRok = GetOstatniRokId()
Dialog()

#ifdef FORTE

Rejestr()

#else

SetKey(bDef, "id")
int errDef = GetRec(bDef, FS)
while !errDef
	if ( GetField(bDef, "rZs") == FKUTIL_TYPREJ_SPRZEDAZ || GetField(bDef, "rZs") == FKUTIL_TYPREJ_EKSPORT ) && GetField(bDef, "wykazuj") == 1 then
//	if ( GetField(bDef, "rZs") == FKUTIL_TYPREJ_SPRZEDAZ || GetField(bDef, "rZs") == FKUTIL_TYPREJ_EKSPORT ) && FKUTIL_PODTYPREJ_DT != GetField(bDef, "srTrwale") && GetField(bDef, "wykazuj") == 1 then
		PopUp(1, (using "Rejestr: %s", GetField(bDef, "rNazwa")))
		Rejestr(GetField(bDef, "id"), GetField(bDef, "srTrwale"))
	endif
	errDef = GetRec(bDef, NX)
wend

#endif

Header(1)
Legenda()

licznik = sumParam( TYPE_OP ) - sumParam( TYPE_OST ) - sumParam( TYPE_OTF )
mianownik= sumParam( TYPE_OP ) + sumParam( TYPE_ON ) + sumParam( TYPE_S ) - sumParam( TYPE_OST ) - sumParam( TYPE_OTF )

if !mianownik then
	Message "Wartoci poszczeglnych wspczynnikw nie pozwalaj na\npoprawne wyliczenie proporcji VAT. {{icon=!}}"
	strProp = "BD (mianownik = 0)"
else	
	proporcja = (licznik / mianownik) * 100
	strProp = using "%.2f%%", proporcja
endif

SetFont("nagwek")
print using "\nWzr:\t%s\n", PROPWZOR
print using "Proporcja:\tP(%%) = %s\n\n", strProp

tabela #tblNglParam
	kolumna 1, "Parametr"
	kolumna 2, "Znacznik"
	kolumna 3, "Opis parametru"
	kolumna 4, "Suma netto"
koniec

if daneVAT then
	tabela #tblNglVAT, At 150, #Y
		kolumna 1, "Okres"
		kolumna 2, "Nr ew."
		kolumna 3, "Nr dokumentu"
		kolumna 4, "Stawka"
		kolumna 5, "VAT"
		kolumna 6, "Netto"
	koniec
endif

print lf

for idxParam = 1 to idxParam > TYPE__COUNT
	tabela #tblParam
		kolumna 1, skrotParam(idxParam)
		kolumna 2, Mid(znacznikParam(idxParam), 1, 1)
		kolumna 3, nameParam(idxParam)
		kolumna 4, Kwota(sumParam(idxParam))
	koniec
	if daneVAT then
		lstMapParam(idxParam).Sort()
		for indx = 1 to indx > lstMapParam(idxParam).Size()
			idxRej = lstMapParam(idxParam).Get(indx)
			tabela #tblVAT, At 150, #Y
				kolumna 1, lstRej(idxRej).okr
				kolumna 2, lstRej(idxRej).nrew
				kolumna 3, lstRej(idxRej).nrwl  
				select case lstRej(idxRej).stawka
				case STAWKA_ZWOL
					kolumna 4, STAWKA_ZWOL_SHOPIS
				case STAWKA_NIEOP
					kolumna 4, STAWKA_NIEOP_SHOPIS
				case STAWKA_BEZP
					kolumna 4, STAWKA_BEZP_SHOPIS
				case else
					kolumna 4, (using "%.2f%%", lstRej(idxRej).stawka)
				endselect
				kolumna 5, Kwota(lstRej(idxRej).vat)
				kolumna 6, Kwota(lstRej(idxRej).netto)
			koniec
		next indx
	endif
next idxParam	

Footer(1)

dbCloseAll()
close
